# Tomatensimulator

## States

Hier nochmal die Liste, die wir damals formuliert haben:

* dist enemy
* dist retreat
* motionstate (me / enemy) --> die eigentliche Action wäre wichtiger, der motionstate kann vielleicht zusätzlich getrackt werden
* flight state (me / enemy)
* combostate (me / enemy)
* HP (me / enemy)
* MP (me / enemy)
* character ?

Dazu Ideen, wie man das definieren könnte, um möglichst wenig states zu haben.
* Charakter muss denke ich nicht als Teil des States definiert werden.
* Distancen kann man in zwei oder drei Werte aufteilen:
 * dist enemy: in Angriffsreichweite / (nah) / nicht in Reichweite (bzw. weiter weg als "nah")
 * dist retreat: in corner / in center / in enemy corner (dabei muss die Richtung, in die die Charaktere gerade stehen, berücksichtigt werden. Fest kodieren geht da nicht)
* HP / MP: low/middle/high? ; enoughForSkillX / ; vielleicht auch nur der Vergleich: me > enemy, me ~ enemy, me < enemy
* combostate: nothing / comboX possible! (vielleicht muss die combo-Behandlung auch gar nicht vom learner betrachtet werden, sondern überschreibt einfach alles andere?)

## Learner und Decider

Insgesamt erhalten wir den aktuell beobachteten State (welcher einige Frames zurückliegt) als Input, und müssen daraus eine Aktion erzeugen. Ich denke, es wäre sinnvoll, anstatt eines direkten Learners zwei Learner zu nutzen. Hier also meine Idee:

* Der StateLearner versucht, aus der Beobachtung den aktuellen State zu ermitteln. Das gute daran ist, dass hierbei immer ein richtig oder falsch im Nachhinein bestimmt werden kann, weswegen dieser Learner mit der Zeit relativ sicher werden sollte.
 * Am Besten wäre es, wenn er sogar nicht nur einen State als Ergebnis ausgibt, sondern eine Menge an States mit ihren verschiedenen Wahrscheinlichkeiten.
 * In einzelnen Bestandteilen müssten States sogar zu 100% korrekt vorausgesagt werden können, nämlich dort, wo nur unser Character entscheidet. Wir wissen ja, dass wir im letzten Frame gesprungen sind, auch wenn das noch nicht Teil der Beobachtung war. Dadurch kann der StateLearner noch verbessert werden.
* Ein TacticsDecider sollte dann aus diesen States und der aktuellen Policy eine Aktion vorschlagen.
 * Bei mehreren möglichen States werden die Aktionen für all diese States ermittelt, und die Aktion mit der höchsten Wahrscheinlichkeit gewählt.
  * Bsp. 1: 30% StateA, 70% StateB. StateA --> ActionX, StateB --> ActionY. ActionY erhält 70% und wird gewählt.
  * Bsp. 2: 30% StateA, 40% StateB, 30% StateC. StateA --> ActionX, StateB --> ActionY, StateC --> ActionX. ActionX erhält 60% und wird gewählt.
 * Eigentlich muss berücksichtigt werden, dass jeder State mehrere mögliche Mappings mit mehreren Wahrscheinlichkeiten haben kann.
  * Bsp. 3: 30% A, 70% B. (A --> X)=90%, (A --> Y)=10%, (B --> X)=40%, (B --> Y)=60%. ActionX erhält 55% und wird gewählt.
* Der TacticsLearner betrachtet nur die tatsächlichen Zustände und die gewählten Aktionen und ändert anhand ihren Erfolgs die aktuelle Policy. Da es kein richtig oder falsch gibt, muss eine Heuristik H bestimmt werden, die den Erfolg messbar macht.
 * nach Bsp1: Es war tatsächlich StateB. H = x. Demnach wird das Mapping (StateB --> ActionY) mit x Punkten bewertet.
 * nach Bsp2: Es wr tatsächlich StateB, nicht A oder C. H = x. Demnach wird das Mapping (StateB --> ActionX) mit x Punkten bewertet.

### SkillLearner

Vielleicht wäre es sinnvoll, für Lud einen SkillLearner einzubauen, welcher Kosten und Nutzen von Luds Skills, sowie seine Bewegungsmuster ermittelt. Das könnte sowohl für die StateEstimation, als auch den TacticsLearner sinnvoll sein. Kommt aber darauf an, wie die beiden implementiert werden.

## Attacks

Vielleicht wäre es sinnvoll, Entscheidungen nicht direkt zu bestimmten Angriffen zu führen (StateA -> AngriffA), sondern nach Kategorien zu entscheiden.

Also erst die Entscheidung, was man gerade erreichen will: MP sammeln, Schaden vermeiden, Schaden austeilen, Combo brechen, Combo erzeugen oder besser positionieren.

Dann die Entscheidung, ob man lieber angreift oder verteidigt, um sein Ziel zu erreichen.

Dann, wo man angreift/verteidigt: low,middle,high,throw. Da muss man den Gegner einschätzen.

Dann, ob der Angriff überhaupt aktuell durchführbar ist (wegen der MP).

Dann, welche Attacken die schnellsten sind, bzw. aktuelle Recovery-Frames abbrechen können oder selbst abgebrochen werden können (was schnellere Angriffe ermöglicht).

Diese Entscheidungen müssen nicht zwingend konsekutiv sein, sondern lieber gewichtend: Wenn ich MP sammeln will, kriegen alle Attacken einen Wert proportional zu ihrer MP-Bilanz. Diejenigen, die in der passenden Höhe sind, kriegen noch mehr Punkte. usw...
Dadurch müssen Entscheidungen auch nicht fest sein, sondern können fuzzy bleiben. Man kann also zB. einen Fokus auf MP und Schaden legen, und dafür die Verteidigung ignorieren.

### Throw / Projectiles

Das sind ganz interessante Sondertypen.

* Throw-Angriffe werfen einen getroffenen Gegner quasi über die Schulter. Wenn man in die Ecke gedrängt wurde, kann man somit das Blatt wenden. Sie können nur durch AIR_GUARD geblockt werden (oder man weicht ihnen aus).
* Projectiles erzeugen magische Bälle, die (ziemlich langsam, nach meiner Erfahrung) übers Feld auf den Gegner zu fliegen. Man muss also nicht in Reichweite sein, allerdings schätze ich, dass man sie relativ leicht blocken / umgehen könnte, da sie wie gesagt nicht besonders schnell aussahen.
